<?php
require 'renderer.php';

class Mailhandling extends Renderer {
    
    public function __construct() {
        parent::__construct();
        if (!$this->connectToImap()) {
            $this->templateName = 'imaperror';
            return;
        }
    }
    
    protected function fetchEmailHeader(array &$content): void {
        $header = imap_headerinfo($this->mbox, $this->uid);
        $content['sender'] = imap_utf8($header->fromaddress);
        $content['receiver'] = imap_utf8($header->toaddress);
        $content['subject'] = imap_utf8($header->subject);
        $content['senddate'] = date('d.m.Y H:i:s', strtotime($header->date));
    }
    
    protected function fetchEmailBody($messageStructure, array &$content): void {
        $message = imap_fetchbody($this->mbox, $this->uid, 1.1, FT_PEEK); 
        if($message == '') {
            $message = imap_fetchbody($this->mbox, $this->uid, 1, FT_PEEK);
        }
        $decodedMessage = quoted_printable_decode($message);
        if (isset($messageStructure->parts) && isset($messageStructure->parts[1]) && isset($messageStructure->parts[1]->parameters)
            && isset($messageStructure->parts[1]->parameters) && is_array($messageStructure->parts[1]->parameters) && isset($messageStructure->parts[1]->parameters[0]->value) && strtolower($messageStructure->parts[1]->parameters[0]->value) != 'utf-8') {
            $decodedMessage = utf8_encode($decodedMessage);
        }
        $content['emailbody'] = nl2br($decodedMessage);
    }

    
    protected function getAttachments($structure): array {
        $attachments = [];
        if(isset($structure->parts) && count($structure->parts)) {
            for($i = 0; $i < count($structure->parts); $i++) {
                $attachments[$i] = [
                    'is_attachment' => false,
                    'filename' => '',
                    'name' => '',
                    'attachment' => ''];

                if($structure->parts[$i]->ifdparameters) {
                    foreach($structure->parts[$i]->dparameters as $object) {
                        if(strtolower($object->attribute) == 'filename') {
                            $attachments[$i]['is_attachment'] = true;
                            $attachments[$i]['filename'] = $object->value;
                        }
                    }
                }

                if($structure->parts[$i]->ifparameters) {
                    foreach($structure->parts[$i]->parameters as $object) {
                        if(strtolower($object->attribute) == 'name') {
                            $attachments[$i]['is_attachment'] = true;
                            $attachments[$i]['name'] = $object->value;
                        }
                    }
                }

                if($attachments[$i]['is_attachment']) {
                    $attachments[$i]['attachment'] = imap_fetchbody($this->mbox, $this->uid, $i+1);
                    if($structure->parts[$i]->encoding == 3) { // 3 = BASE64
                        $attachments[$i]['attachment'] = base64_decode($attachments[$i]['attachment']);
                    }
                    elseif($structure->parts[$i]->encoding == 4) { // 4 = QUOTED-PRINTABLE
                        $attachments[$i]['attachment'] = quoted_printable_decode($attachments[$i]['attachment']);
                    }
                }
                if ($attachments[$i]['is_attachment']) {
                }
            }
        }
        $realAttachments = array_filter($attachments, function($attachment) {
            return $attachment['is_attachment'];
        });
        return $realAttachments;
    }
}
